# Class MenuDragMouseEvent

java.lang.Object
java.util.EventObject
java.awt.AWTEvent
java.awt.event.ComponentEvent
java.awt.event.InputEvent
java.awt.event.MouseEvent
javax.swing.event.MenuDragMouseEvent

All Implemented Interfaces:
  `Serializable`

public class MenuDragMouseEvent extends MouseEvent
MenuDragMouseEvent is used to notify interested parties that the menu element has received a MouseEvent forwarded to it under drag conditions.

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. As of 1.4, support for long term storage of all JavaBeans has been added to the `java.beans` package. Please see `XMLEncoder`.

- ## Field Summary

  ### Fields declared in class MouseEvent

  `BUTTON1, BUTTON2, BUTTON3, MOUSE_CLICKED, MOUSE_DRAGGED, MOUSE_ENTERED, MOUSE_EXITED, MOUSE_FIRST, MOUSE_LAST, MOUSE_MOVED, MOUSE_PRESSED, MOUSE_RELEASED, MOUSE_WHEEL, NOBUTTON`
  Modifier and Type
  Field
  Description
  `static final int`
  `BUTTON1`
  Indicates mouse button #1; used by `MouseEvent.getButton()`.
  `static final int`
  `BUTTON2`
  Indicates mouse button #2; used by `MouseEvent.getButton()`.
  `static final int`
  `BUTTON3`
  Indicates mouse button #3; used by `MouseEvent.getButton()`.
  `static final int`
  `MOUSE_CLICKED`
  The "mouse clicked" event.
  `static final int`
  `MOUSE_DRAGGED`
  The "mouse dragged" event.
  `static final int`
  `MOUSE_ENTERED`
  The "mouse entered" event.
  `static final int`
  `MOUSE_EXITED`
  The "mouse exited" event.
  `static final int`
  `MOUSE_FIRST`
  The first number in the range of ids used for mouse events.
  `static final int`
  `MOUSE_LAST`
  The last number in the range of ids used for mouse events.
  `static final int`
  `MOUSE_MOVED`
  The "mouse moved" event.
  `static final int`
  `MOUSE_PRESSED`
  The "mouse pressed" event.
  `static final int`
  `MOUSE_RELEASED`
  The "mouse released" event.
  `static final int`
  `MOUSE_WHEEL`
  The "mouse wheel" event.
  `static final int`
  `NOBUTTON`
  Indicates no mouse buttons; used by `MouseEvent.getButton()`.

  ### Fields declared in class InputEvent

  `ALT_DOWN_MASK, ALT_GRAPH_DOWN_MASK, ALT_GRAPH_MASK, ALT_MASK, BUTTON1_DOWN_MASK, BUTTON1_MASK, BUTTON2_DOWN_MASK, BUTTON2_MASK, BUTTON3_DOWN_MASK, BUTTON3_MASK, CTRL_DOWN_MASK, CTRL_MASK, META_DOWN_MASK, META_MASK, SHIFT_DOWN_MASK, SHIFT_MASK`
  Modifier and Type
  Field
  Description
  `static final int`
  `ALT_DOWN_MASK`
  The Alt key extended modifier constant.
  `static final int`
  `ALT_GRAPH_DOWN_MASK`
  The AltGraph key extended modifier constant.
  `static final int`
  `ALT_GRAPH_MASK`
  Deprecated.
  It is recommended that ALT_GRAPH_DOWN_MASK and `InputEvent.getModifiersEx()` be used instead
  `static final int`
  `ALT_MASK`
  Deprecated.
  It is recommended that ALT_DOWN_MASK and `InputEvent.getModifiersEx()` be used instead
  `static final int`
  `BUTTON1_DOWN_MASK`
  The Mouse Button1 extended modifier constant.
  `static final int`
  `BUTTON1_MASK`
  Deprecated.
  It is recommended that BUTTON1_DOWN_MASK and `InputEvent.getModifiersEx()` be used instead
  `static final int`
  `BUTTON2_DOWN_MASK`
  The Mouse Button2 extended modifier constant.
  `static final int`
  `BUTTON2_MASK`
  Deprecated.
  It is recommended that BUTTON2_DOWN_MASK and `InputEvent.getModifiersEx()` be used instead.
  `static final int`
  `BUTTON3_DOWN_MASK`
  The Mouse Button3 extended modifier constant.
  `static final int`
  `BUTTON3_MASK`
  Deprecated.
  It is recommended that BUTTON3_DOWN_MASK and `InputEvent.getModifiersEx()` be used instead.
  `static final int`
  `CTRL_DOWN_MASK`
  The Control key extended modifier constant.
  `static final int`
  `CTRL_MASK`
  Deprecated.
  It is recommended that CTRL_DOWN_MASK and `InputEvent.getModifiersEx()` be used instead
  `static final int`
  `META_DOWN_MASK`
  The Meta key extended modifier constant.
  `static final int`
  `META_MASK`
  Deprecated.
  It is recommended that META_DOWN_MASK and `InputEvent.getModifiersEx()` be used instead
  `static final int`
  `SHIFT_DOWN_MASK`
  The Shift key extended modifier constant.
  `static final int`
  `SHIFT_MASK`
  Deprecated.
  It is recommended that SHIFT_DOWN_MASK and `InputEvent.getModifiersEx()` be used instead

  ### Fields declared in class ComponentEvent

  `COMPONENT_FIRST, COMPONENT_HIDDEN, COMPONENT_LAST, COMPONENT_MOVED, COMPONENT_RESIZED, COMPONENT_SHOWN`
  Modifier and Type
  Field
  Description
  `static final int`
  `COMPONENT_FIRST`
  The first number in the range of ids used for component events.
  `static final int`
  `COMPONENT_HIDDEN`
  This event indicates that the component was rendered invisible.
  `static final int`
  `COMPONENT_LAST`
  The last number in the range of ids used for component events.
  `static final int`
  `COMPONENT_MOVED`
  This event indicates that the component's position changed.
  `static final int`
  `COMPONENT_RESIZED`
  This event indicates that the component's size changed.
  `static final int`
  `COMPONENT_SHOWN`
  This event indicates that the component was made visible.

  ### Fields declared in class AWTEvent

  `ACTION_EVENT_MASK, ADJUSTMENT_EVENT_MASK, COMPONENT_EVENT_MASK, consumed, CONTAINER_EVENT_MASK, FOCUS_EVENT_MASK, HIERARCHY_BOUNDS_EVENT_MASK, HIERARCHY_EVENT_MASK, id, INPUT_METHOD_EVENT_MASK, INVOCATION_EVENT_MASK, ITEM_EVENT_MASK, KEY_EVENT_MASK, MOUSE_EVENT_MASK, MOUSE_MOTION_EVENT_MASK, MOUSE_WHEEL_EVENT_MASK, PAINT_EVENT_MASK, RESERVED_ID_MAX, TEXT_EVENT_MASK, WINDOW_EVENT_MASK, WINDOW_FOCUS_EVENT_MASK, WINDOW_STATE_EVENT_MASK`
  Modifier and Type
  Field
  Description
  `static final long`
  `ACTION_EVENT_MASK`
  The event mask for selecting action events.
  `static final long`
  `ADJUSTMENT_EVENT_MASK`
  The event mask for selecting adjustment events.
  `static final long`
  `COMPONENT_EVENT_MASK`
  The event mask for selecting component events.
  `protected boolean`
  `consumed`
  Controls whether or not the event is sent back down to the peer once the source has processed it - false means it's sent to the peer; true means it's not.
  `static final long`
  `CONTAINER_EVENT_MASK`
  The event mask for selecting container events.
  `static final long`
  `FOCUS_EVENT_MASK`
  The event mask for selecting focus events.
  `static final long`
  `HIERARCHY_BOUNDS_EVENT_MASK`
  The event mask for selecting hierarchy bounds events.
  `static final long`
  `HIERARCHY_EVENT_MASK`
  The event mask for selecting hierarchy events.
  `protected int`
  `id`
  The event's id.
  `static final long`
  `INPUT_METHOD_EVENT_MASK`
  The event mask for selecting input method events.
  `static final long`
  `INVOCATION_EVENT_MASK`
  The event mask for selecting invocation events.
  `static final long`
  `ITEM_EVENT_MASK`
  The event mask for selecting item events.
  `static final long`
  `KEY_EVENT_MASK`
  The event mask for selecting key events.
  `static final long`
  `MOUSE_EVENT_MASK`
  The event mask for selecting mouse events.
  `static final long`
  `MOUSE_MOTION_EVENT_MASK`
  The event mask for selecting mouse motion events.
  `static final long`
  `MOUSE_WHEEL_EVENT_MASK`
  The event mask for selecting mouse wheel events.
  `static final long`
  `PAINT_EVENT_MASK`
  The event mask for selecting paint events.
  `static final int`
  `RESERVED_ID_MAX`
  The maximum value for reserved AWT event IDs.
  `static final long`
  `TEXT_EVENT_MASK`
  The event mask for selecting text events.
  `static final long`
  `WINDOW_EVENT_MASK`
  The event mask for selecting window events.
  `static final long`
  `WINDOW_FOCUS_EVENT_MASK`
  The event mask for selecting window focus events.
  `static final long`
  `WINDOW_STATE_EVENT_MASK`
  The event mask for selecting window state events.

  ### Fields declared in class EventObject

  `source`
  Modifier and Type
  Field
  Description
  `protected Object`
  `source`
  The object on which the Event initially occurred.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MenuDragMouseEvent(Component source, int id, long when, int modifiers, int x, int y, int clickCount, boolean popupTrigger, MenuElement[] p, MenuSelectionManager m)`
  Constructs a MenuDragMouseEvent object.
  `MenuDragMouseEvent(Component source, int id, long when, int modifiers, int x, int y, int xAbs, int yAbs, int clickCount, boolean popupTrigger, MenuElement[] p, MenuSelectionManager m)`
  Constructs a MenuDragMouseEvent object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `MenuSelectionManager`
  `getMenuSelectionManager()`
  Returns the current menu selection manager.
  `MenuElement[]`
  `getPath()`
  Returns the path to the selected menu item.

  ### Methods declared in class MouseEvent

  `getButton, getClickCount, getLocationOnScreen, getMouseModifiersText, getPoint, getX, getXOnScreen, getY, getYOnScreen, isPopupTrigger, paramString, translatePoint`
  Modifier and Type
  Method
  Description
  `int`
  `getButton()`
  Returns which, if any, of the mouse buttons has changed state.
  `int`
  `getClickCount()`
  Returns the number of mouse clicks associated with this event.
  `Point`
  `getLocationOnScreen()`
  Returns the absolute x, y position of the event.
  `static String`
  `getMouseModifiersText(int modifiers)`
  Returns a `String` instance describing the modifier keys and mouse buttons that were down during the event, such as "Shift", or "Ctrl+Shift".
  `Point`
  `getPoint()`
  Returns the x,y position of the event relative to the source component.
  `int`
  `getX()`
  Returns the horizontal x position of the event relative to the source component.
  `int`
  `getXOnScreen()`
  Returns the absolute horizontal x position of the event.
  `int`
  `getY()`
  Returns the vertical y position of the event relative to the source component.
  `int`
  `getYOnScreen()`
  Returns the absolute vertical y position of the event.
  `boolean`
  `isPopupTrigger()`
  Returns whether or not this mouse event is the popup menu trigger event for the platform.
  `String`
  `paramString()`
  Returns a parameter string identifying this event.
  `void`
  `translatePoint(int x, int y)`
  Translates the event's coordinates to a new position by adding specified `x` (horizontal) and `y` (vertical) offsets.

  ### Methods declared in class InputEvent

  `consume, getMaskForButton, getModifiers, getModifiersEx, getModifiersExText, getWhen, isAltDown, isAltGraphDown, isConsumed, isControlDown, isMetaDown, isShiftDown`
  Modifier and Type
  Method
  Description
  `void`
  `consume()`
  Consumes this event so that it will not be processed in the default manner by the source which originated it.
  `static int`
  `getMaskForButton(int button)`
  A method to obtain a mask for any existing mouse button.
  `int`
  `getModifiers()`
  Deprecated.
  It is recommended that extended modifier keys and `InputEvent.getModifiersEx()` be used instead
  `int`
  `getModifiersEx()`
  Returns the extended modifier mask for this event.
  `static String`
  `getModifiersExText(int modifiers)`
  Returns a String describing the extended modifier keys and mouse buttons, such as "Shift", "Button1", or "Ctrl+Shift".
  `long`
  `getWhen()`
  Returns the difference in milliseconds between the timestamp of when this event occurred and midnight, January 1, 1970 UTC.
  `boolean`
  `isAltDown()`
  Returns whether or not the Alt modifier is down on this event.
  `boolean`
  `isAltGraphDown()`
  Returns whether or not the AltGraph modifier is down on this event.
  `boolean`
  `isConsumed()`
  Returns whether or not this event has been consumed.
  `boolean`
  `isControlDown()`
  Returns whether or not the Control modifier is down on this event.
  `boolean`
  `isMetaDown()`
  Returns whether or not the Meta modifier is down on this event.
  `boolean`
  `isShiftDown()`
  Returns whether or not the Shift modifier is down on this event.

  ### Methods declared in class ComponentEvent

  `getComponent`
  Modifier and Type
  Method
  Description
  `Component`
  `getComponent()`
  Returns the originator of the event.

  ### Methods declared in class AWTEvent

  `getID, setSource, toString`
  Modifier and Type
  Method
  Description
  `int`
  `getID()`
  Returns the event type.
  `void`
  `setSource(Object newSource)`
  Retargets an event to a new source.
  `String`
  `toString()`
  Returns a String representation of this object.

  ### Methods declared in class EventObject

  `getSource`
  Modifier and Type
  Method
  Description
  `Object`
  `getSource()`
  The object on which the Event initially occurred.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### MenuDragMouseEvent

    public MenuDragMouseEvent(Component source, int id, long when, int modifiers, int x, int y, int clickCount, boolean popupTrigger, MenuElement[] p, MenuSelectionManager m)
    Constructs a MenuDragMouseEvent object.

    Absolute coordinates xAbs and yAbs are set to source's location on screen plus relative coordinates x and y. xAbs and yAbs are set to zero if the source is not showing.

    Parameters:
      `source` - the Component that originated the event (typically `this`)
      `id` - an int specifying the type of event, as defined in `MouseEvent`
      `when` - a long identifying the time the event occurred
      `modifiers` - an int specifying any modifier keys held down, as specified in `InputEvent`
      `x` - an int specifying the horizontal position at which the event occurred, in pixels
      `y` - an int specifying the vertical position at which the event occurred, in pixels
      `clickCount` - an int specifying the number of mouse-clicks
      `popupTrigger` - a boolean -- true if the event {should?/did?} trigger a popup
      `p` - an array of MenuElement objects specifying a path to a menu item affected by the drag
      `m` - a MenuSelectionManager object that handles selections
    See Also:
      - `MouseEvent(java.awt.Component, int, long, int, int, int, int, int, int, boolean, int)`

  - ### MenuDragMouseEvent

    public MenuDragMouseEvent(Component source, int id, long when, int modifiers, int x, int y, int xAbs, int yAbs, int clickCount, boolean popupTrigger, MenuElement[] p, MenuSelectionManager m)
    Constructs a MenuDragMouseEvent object.

    Even if inconsistent values for relative and absolute coordinates are passed to the constructor, the MenuDragMouseEvent instance is still created.

    Parameters:
      `source` - the Component that originated the event (typically `this`)
      `id` - an int specifying the type of event, as defined in `MouseEvent`
      `when` - a long identifying the time the event occurred
      `modifiers` - an int specifying any modifier keys held down, as specified in `InputEvent`
      `x` - an int specifying the horizontal position at which the event occurred, in pixels
      `y` - an int specifying the vertical position at which the event occurred, in pixels
      `xAbs` - an int specifying the horizontal absolute position at which the event occurred, in pixels
      `yAbs` - an int specifying the vertical absolute position at which the event occurred, in pixels
      `clickCount` - an int specifying the number of mouse-clicks
      `popupTrigger` - a boolean -- true if the event {should?/did?} trigger a popup
      `p` - an array of MenuElement objects specifying a path to a menu item affected by the drag
      `m` - a MenuSelectionManager object that handles selections
    Since:
      1.6
    See Also:
      - `MouseEvent(java.awt.Component, int, long, int, int, int, int, int, int, boolean, int)`

- ## Method Details

  - ### getPath

    public MenuElement[] getPath()
    Returns the path to the selected menu item.
    Returns:
      an array of MenuElement objects representing the path value

  - ### getMenuSelectionManager

    public MenuSelectionManager getMenuSelectionManager()
    Returns the current menu selection manager.
    Returns:
      a MenuSelectionManager object